﻿# https://www.youtube.com/watch?v=5hyd7k4WZeI
init python:
    class chance_bar_pointer(renpy.Displayable):
        def __init__(self):
            super(renpy.Displayable,self).__init__()
            self.image = "chance_bar_pointer"
            self.y = 0
            self.y_velocity = 40
            self.moving = True
        def render(self,width,height,st,at):
            if self.moving:
                self.y += self.y_velocity
                if self.y > 1000:
                    self.y = 0

            t = Transform(self.image)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (0, self.y))

            renpy.redraw(self, 0)
            return rv

    class bar_chance:
        def __init__(self, name, chance, color, uses = None):
            self.name = name
            self.chance = chance
            self.color = color
            self.uses = uses

    class chance_bar_class:
        def __init__(self, chances = None):
            self.chances = chances or []
            self.total = 100
            self.size = 990
            self.xsize = 400
            self.bar = chance_bar_pointer()
            self.current = None
            self.calculate()
        def stop(self):
            if self.bar.moving:
                renpy.play("iso board/win.ogg", "sound")
                self.bar.moving = False
                self.bar.y = clamp(3, self.bar.y + random.randint(-20,20), 995)

                count = 0
                for i in self.chances:
                    count += i.chance*self.size
                    self.current = i
                    if self.bar.y < count:
                        break
            # else:
            #     self.reset()
        def reset(self):
            self.bar.moving = True
            self.current = None
        def scramble(self):
            random.shuffle(self.chances)
        def add_chance(self, chance):
            self.chances.append(chance)
            self.calculate()
        def remove_chance(self, chance):
            try:
                self.chances.remove(chance)
            except:
                pass
            self.calculate()
        def calculate(self):
            total = 0
            for i in self.chances:
                total += i.chance
            self.total = total
            self.size = int(1000/total)
transform chance_bar_animation:
    on idle:
        ease .5 alpha 1 additive 0
    on selected_idle:
        ease .5 alpha .5 additive .5
        ease .5 alpha 1 additive 0
        repeat

screen chance_bar_screen(g, gg = None):
    hbox:
        align .2,.5
        vbox:
            for i in g.chances:
                button:
                    xysize g.xsize,(g.size*i.chance)
                    background i.color
                    at chance_bar_animation
                    vbox:
                        text str(i.name)
                        # text str(i.chance)
                    action NullAction(), SelectedIf(i == g.current)
        frame:
            align .23,.5 padding 0,0 xoffset -30
            ysize 1000
            background None
            add g.bar yoffset -16
    button:
        background None
        action Function(g.stop)
    if g.current:
        timer 2 action Function(gg.thrown, g.current.name)





